summaryrefslogtreecommitdiff
path: root/lib
diff options
context:
space:
mode:
authorRuss Cox <rsc@golang.org>2022-12-05 23:07:54 -0500
committerGopher Robot <gobot@golang.org>2022-12-07 00:25:27 +0000
commit10bb003401060a48d5836c3af483de562f980ac5 (patch)
tree83647461fce8cc062fa904b99fc4232488b9e1be /lib
parent7dc9fcb13de7bb20b11f6a526865545cc9142c2c (diff)
downloadgo-git-10bb003401060a48d5836c3af483de562f980ac5.tar.gz
lib/time: update to 2022g/2022g
Commit generated by update.bash. For #22487. Change-Id: I6a995a3baea7c511b9bd5155f81d8b8e2cdff09d Reviewed-on: https://go-review.googlesource.com/c/go/+/455356 Reviewed-by: Heschi Kreinick <heschi@google.com> Run-TryBot: Russ Cox <rsc@golang.org> Auto-Submit: Russ Cox <rsc@golang.org> TryBot-Result: Gopher Robot <gobot@golang.org>
Diffstat (limited to 'lib')
-rw-r--r--lib/time/mkzip.go94
-rwxr-xr-xlib/time/update.bash70
-rw-r--r--lib/time/zoneinfo.zipbin428823 -> 397464 bytes
3 files changed, 153 insertions, 11 deletions
diff --git a/lib/time/mkzip.go b/lib/time/mkzip.go
new file mode 100644
index 0000000000..3920b11b6c
--- /dev/null
+++ b/lib/time/mkzip.go
@@ -0,0 +1,94 @@
+// Copyright 2022 The Go Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style
+// license that can be found in the LICENSE file.
+
+//go:build ignore
+
+// Mkzip writes a zoneinfo.zip with the content of the current directory
+// and its subdirectories, with no compression, suitable for package time.
+//
+// Usage:
+//
+// go run ../../mkzip.go ../../zoneinfo.zip
+//
+// We use this program instead of 'zip -0 -r ../../zoneinfo.zip *' to get
+// a reproducible generator that does not depend on which version of the
+// external zip tool is used or the ordering of file names in a directory
+// or the current time.
+package main
+
+import (
+ "archive/zip"
+ "bytes"
+ "flag"
+ "fmt"
+ "hash/crc32"
+ "io/fs"
+ "log"
+ "os"
+ "path/filepath"
+ "strings"
+)
+
+func usage() {
+ fmt.Fprintf(os.Stderr, "usage: go run mkzip.go ../../zoneinfo.zip\n")
+ os.Exit(2)
+}
+
+func main() {
+ log.SetPrefix("mkzip: ")
+ log.SetFlags(0)
+ flag.Usage = usage
+ flag.Parse()
+ args := flag.Args()
+ if len(args) != 1 || !strings.HasSuffix(args[0], ".zip") {
+ usage()
+ }
+
+ var zb bytes.Buffer
+ zw := zip.NewWriter(&zb)
+ seen := make(map[string]bool)
+ err := filepath.WalkDir(".", func(path string, d fs.DirEntry, err error) error {
+ if d.IsDir() {
+ return nil
+ }
+ data, err := os.ReadFile(path)
+ if err != nil {
+ log.Fatal(err)
+ }
+ if strings.HasSuffix(path, ".zip") {
+ log.Fatalf("unexpected file during walk: %s", path)
+ }
+ name := filepath.ToSlash(path)
+ w, err := zw.CreateRaw(&zip.FileHeader{
+ Name: name,
+ Method: zip.Store,
+ CompressedSize64: uint64(len(data)),
+ UncompressedSize64: uint64(len(data)),
+ CRC32: crc32.ChecksumIEEE(data),
+ })
+ if err != nil {
+ log.Fatal(err)
+ }
+ if _, err := w.Write(data); err != nil {
+ log.Fatal(err)
+ }
+ seen[name] = true
+ return nil
+ })
+ if err != nil {
+ log.Fatal(err)
+ }
+ if err := zw.Close(); err != nil {
+ log.Fatal(err)
+ }
+ if len(seen) == 0 {
+ log.Fatalf("did not find any files to add")
+ }
+ if !seen["US/Eastern"] {
+ log.Fatalf("did not find US/Eastern to add")
+ }
+ if err := os.WriteFile(args[0], zb.Bytes(), 0666); err != nil {
+ log.Fatal(err)
+ }
+}
diff --git a/lib/time/update.bash b/lib/time/update.bash
index d49127b275..48606b9de4 100755
--- a/lib/time/update.bash
+++ b/lib/time/update.bash
@@ -5,35 +5,83 @@
# This script rebuilds the time zone files using files
# downloaded from the ICANN/IANA distribution.
-# Consult https://www.iana.org/time-zones for the latest versions.
+#
+# To prepare an update for a new Go release,
+# consult https://www.iana.org/time-zones for the latest versions,
+# update CODE and DATA below, and then run
+#
+# ./update.bash -commit
+#
+# That will prepare the files and create the commit.
+#
+# To review such a commit (as the reviewer), use:
+#
+# git codereview change NNNNNN # CL number
+# cd lib/time
+# ./update.bash
+#
+# If it prints "No updates needed.", then the generated files
+# in the CL match the update.bash in the CL.
# Versions to use.
-CODE=2022f
-DATA=2022f
+CODE=2022g
+DATA=2022g
set -e
+
+cd $(dirname $0)
rm -rf work
mkdir work
+go build -o work/mkzip mkzip.go # build now for correct paths in build errors
cd work
mkdir zoneinfo
-curl -L -O https://www.iana.org/time-zones/repository/releases/tzcode$CODE.tar.gz
-curl -L -O https://www.iana.org/time-zones/repository/releases/tzdata$DATA.tar.gz
+curl -sS -L -O https://www.iana.org/time-zones/repository/releases/tzcode$CODE.tar.gz
+curl -sS -L -O https://www.iana.org/time-zones/repository/releases/tzdata$DATA.tar.gz
tar xzf tzcode$CODE.tar.gz
tar xzf tzdata$DATA.tar.gz
-make CFLAGS=-DSTD_INSPIRED AWK=awk TZDIR=zoneinfo posix_only
+if ! make CFLAGS=-DSTD_INSPIRED AWK=awk TZDIR=zoneinfo posix_only >make.out 2>&1; then
+ cat make.out
+ exit 2
+fi
cd zoneinfo
-rm -f ../../zoneinfo.zip
-zip -0 -r ../../zoneinfo.zip *
+../mkzip ../../zoneinfo.zip
cd ../..
-
go generate time/tzdata
-echo
+files="update.bash zoneinfo.zip ../../src/time/tzdata/zipdata.go"
+modified=true
+if git diff --quiet $files; then
+ modified=false
+fi
+
if [ "$1" = "-work" ]; then
echo Left workspace behind in work/.
+ shift
else
rm -rf work
fi
-echo New time zone files in zoneinfo.zip.
+
+if ! $modified; then
+ echo No updates needed.
+ exit 0
+fi
+
+echo Updated for $CODE/$DATA: $files
+
+commitmsg="lib/time: update to $CODE/$DATA
+
+Commit generated by update.bash.
+
+For #22487.
+"
+
+if [ "$1" = "-commit" ]; then
+ echo "Creating commit. Run 'git reset HEAD^' to undo commit."
+ echo
+ git commit -m "$commitmsg" $files
+ echo
+ git log -n1 --stat
+ echo
+fi
diff --git a/lib/time/zoneinfo.zip b/lib/time/zoneinfo.zip
index d44f355c28..9b31ec1994 100644
--- a/lib/time/zoneinfo.zip
+++ b/lib/time/zoneinfo.zip
Binary files differ